package jerozgen.languagereload.gui;

import jerozgen.languagereload.LanguageReload;
import jerozgen.languagereload.access.ILanguageOptionsScreen;
import net.minecraft.class_1077;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_332;
import net.minecraft.class_339;
import net.minecraft.class_344;
import net.minecraft.class_4185;
import net.minecraft.class_4280;
import net.minecraft.class_4587;
import java.util.*;

public abstract class LanguageEntry extends class_4280.class_4281<LanguageEntry> {
    protected static final class_2960 TEXTURE = new class_2960(LanguageReload.MOD_ID, "textures/gui/language_selection.png");
    protected static final int TEXTURE_WIDTH = 64;
    protected static final int TEXTURE_HEIGHT = 64;
    protected static final int HOVERED_V_OFFSET = 24;

    protected final class_310 client = class_310.method_1551();

    protected final String code;
    protected final class_1077 language;
    protected final LinkedList<String> selectedLanguages;
    protected final Runnable refreshListsAction;

    private final List<class_339> buttons = new ArrayList<>();

    protected LanguageListWidget parentList;

    public LanguageEntry(Runnable refreshListsAction, String code, class_1077 language, LinkedList<String> selectedLanguages) {
        this.code = code;
        this.language = language;
        this.selectedLanguages = selectedLanguages;
        this.refreshListsAction = refreshListsAction;
    }

    protected class_4185 addButton(int width, int height, int u, int v, class_4185.class_4241 action) {
        return addButton(width, height, u, v, HOVERED_V_OFFSET, action);
    }

    protected class_4185 addButton(int width, int height, int u, int v, int hoveredVOffset, class_4185.class_4241 action) {
        var button = new class_344(0, 0, width, height, u, v, hoveredVOffset, TEXTURE, TEXTURE_WIDTH, TEXTURE_HEIGHT, action);
        button.field_22764 = false;
        buttons.add(button);
        return button;
    }

    public void toggle() {}

    public void moveUp() {}

    public void moveDown() {}

    protected abstract void renderButtons(ButtonRenderer buttonRenderer, int x, int y);

    @Override
    public void method_25343(class_4587 matrices, int index, int y, int x, int entryWidth, int entryHeight, int mouseX, int mouseY, boolean hovered, float tickDelta) {
        x -= 2;
        y -= 2;
        if (hovered || method_25370() || client.field_1690.method_42446().method_41753()) {
            class_332.method_25294(matrices,
                    x + 1, y + 1, x + entryWidth - 1, y + entryHeight + 3,
                    (hovered || method_25370()) ? 0xA0909090 : 0x50909090);
            buttons.forEach(button -> button.field_22764 = false);
            renderButtons((button, buttonX, buttonY) -> {
                button.method_46421(buttonX);
                button.method_46419(buttonY);
                button.field_22764 = true;
                button.method_25394(matrices, mouseX, mouseY, tickDelta);
            }, x, y);
        }
        client.field_1772.method_1720(matrices, language.comp_1199(), x + 29, y + 3, 0xFFFFFF);
        client.field_1772.method_1720(matrices, language.comp_1198(), x + 29, y + 14, 0x808080);
    }

    @Override
    public class_2561 method_37006() {
        return class_2561.method_43469("narrator.select", language.method_48303());
    }

    @Override
    public boolean method_25402(double mouseX, double mouseY, int button) {
        for (var widget : buttons)
            if (widget.method_25402(mouseX, mouseY, button)) {
                ((ILanguageOptionsScreen) parentList.getScreen()).languagereload_focusList(parentList);
                return true;
            }
        return false;
    }

    public void setParent(LanguageListWidget list) {
        this.parentList = list;
    }

    public LanguageListWidget getParent() {
        return parentList;
    }

    public String getCode() {
        return code;
    }

    public class_1077 getLanguage() {
        return language;
    }

    @FunctionalInterface
    protected interface ButtonRenderer {
        void render(class_4185 button, int x, int y);
    }
}
