package jerozgen.languagereload.gui;

import I;
import java.util.LinkedList;
import net.minecraft.class_1077;
import net.minecraft.class_4185;

public class MovableLanguageEntry extends LanguageEntry {
    private final class_4185 addButton = addButton(15, 24, 0, 0, __ -> add());
    private final class_4185 removeButton = addButton(15, 24, 15, 0, __ -> remove());
    private final class_4185 moveUpButton = addButton(11, 11, 31, 0, __ -> moveUp());
    private final class_4185 moveDownButton = addButton(11, 11, 31, 13, __ -> moveDown());

    public MovableLanguageEntry(Runnable refreshListsAction, String code, class_1077 language, LinkedList<String> selectedLanguages) {
        super(refreshListsAction, code, language, selectedLanguages);
    }

    private boolean isSelected() {
        return selectedLanguages.contains(code);
    }

    private boolean isFirst() {
        return code.equals(selectedLanguages.peekFirst());
    }

    private boolean isLast() {
        return code.equals(selectedLanguages.peekLast());
    }

    private void add() {
        if (method_25370())
            parentList.method_25395(null);
        selectedLanguages.add(code);
        refreshListsAction.run();
    }

    private void remove() {
        if (method_25370())
            parentList.method_25395(null);
        selectedLanguages.remove(code);
        refreshListsAction.run();
    }

    @Override
    public void toggle() {
        if (!isSelected()) add();
        else remove();
    }

    @Override
    public void moveUp() {
        if (!isSelected()) return;
        if (isFirst()) return;
        var index = selectedLanguages.indexOf(code);
        selectedLanguages.add(index - 1, selectedLanguages.remove(index));
        refreshListsAction.run();
    }

    @Override
    public void moveDown() {
        if (!isSelected()) return;
        if (isLast()) return;
        var index = selectedLanguages.indexOf(code);
        selectedLanguages.add(index + 1, selectedLanguages.remove(index));
        refreshListsAction.run();
    }

    @Override
    protected void renderButtons(ButtonRenderer renderer, int x, int y) {
        if (isSelected()) {
            renderer.render(removeButton, x, y);
            if (!isFirst()) renderer.render(moveUpButton, x + removeButton.method_25368() + 1, y);
            if (!isLast()) renderer.render(moveDownButton, x + removeButton.method_25368() + 1, y + moveUpButton.method_25364() + 2);
        } else renderer.render(addButton, x + 7, y);
    }
}
